/*
 Copyright 2002, 2003 Alexandre Gil
                                                                                
 This file is part of mwu-extractor.
                                                                                
 mwu-extractor is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
                                                                                
 mwu-extractor is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
                                                                                
 You should have received a copy of the GNU General Public License
 along with mwu-extractor; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Nome: NGramMask.h
// Objectivo: Interface da classe generica NGramMask.
// Autor: Alexandre Gil
// Data: 09 Dez 2001

#ifndef _H_NGramMask
#define _H_NGramMask

#include "ISVector.h"
#include "Mask.h"

class NGramMask: public ISVector<Mask> {
private:
	short int m;
	bool onlyValid;
private:
  void GenNGram(const Mask& mk, const int level, const int depth);
  void InitSubSets();
  void InitSuperSets();
public:
  NGramMask(const short int m, const bool onlyValid);
	~NGramMask();
  short int NumOfMasks() const;
  short int LeftFilledMask(short int nLeft) const;
};

#endif
