/*
 Copyright 2002, 2003 Alexandre Gil
                                                                                
 This file is part of mwu-extractor.
                                                                                
 mwu-extractor is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
                                                                                
 mwu-extractor is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
                                                                                
 You should have received a copy of the GNU General Public License
 along with mwu-extractor; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Nome: MyUtils.cpp
// Objectivo: Implementacao de utilitarios de uso geral
// Autor: Alexandre Gil
// Data: 01 Fev 2002

#include <string.h>
#include <time.h>
//#include <locale>
#include <iostream>
#include <iomanip>

#include "MyUtils.h"

int str2int(char * s) {
    int res = 0;
	
    for(unsigned int j = 0; j < strlen(s); j++)
	res = res*10 + (s[j] - '0');

    return res;
}

void TimeStamp(std::ostream& output) {
    time_t t1 = time(0);
    struct tm *lt = localtime(&t1);
    output << std::setfill('0') << std::setw(2) << lt->tm_mday << "/";
    output << std::setfill('0') << std::setw(2) << ((lt->tm_mon)+1) << "/";
    output << std::setfill('0') << std::setw(2) << (1900+lt->tm_year) << " ";
    output << std::setfill('0') << std::setw(2) << lt->tm_hour << ":";
    output << std::setfill('0') << std::setw(2) << lt->tm_min << ":";
    output << std::setfill('0') << std::setw(2) << lt->tm_sec;
}

void ClearCRLF(char * s) {
    int j = 0;
    for(int i = 0; s[i] != '\0'; i++)
	if(s[i] != '\r' && s[i] != '\n')
	    s[j++] = s[i];
    s[j] = '\0';
}
