/*
 Copyright 2002, 2003 Alexandre Gil
                                                                                
 This file is part of mwu-extractor.
                                                                                
 mwu-extractor is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
                                                                                
 mwu-extractor is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
                                                                                
 You should have received a copy of the GNU General Public License
 along with mwu-extractor; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Nome: Dictionary.h
// Objectivo: Interface da classe generica Dictionary
//						Implementa um vector de Tokens com a respectiva traducao em texto
//						Recebe um ficheiro de texto com linhas no formato <Token> <' ' | '\t'> <string>.
// 						Na primeira linha recebe o numero de Tokens.
//
// Autor: Alexandre Gil
// Data: 30 Mar 2002

#ifndef _H_Dictionary
#define _H_Dictionary

#include<iostream>
#include<fstream>

#include "Token.h"

typedef char * _String;

class Dictionary {
	private:
		_String * dVec;
		Token numTokens;
		bool erro;
		std::ifstream fDic;
		char current;
	private:
		virtual Token ReadValue();
		virtual void ReadWord(char * s);

		virtual void NextChar();
		virtual void OpenFile(const char * filename);
	public:
		explicit Dictionary(const char * filename);									// pre capacity > 0;
		virtual ~Dictionary();

		virtual const char * String(Token tk) const;   	 // Valid(tk)
		virtual bool Valid(Token tk) const;								
    virtual void Write(std::ostream& output = std::cout) const;

    virtual bool Error() const;
};

#endif
